<template>
  <div class="modal-wrap" v-if="opened" @click="clear">
    <div @click.stop class="modal">
      <div class="modal-title">{{ isEdit ? "Update" : "Create" }} Task</div>
      <div class="modal-content">
        <input-row cols="2">
          <div>
            <label for="name">Name</label>
            <input id="name" v-model="task.name" />
          </div>
          <user-selector label="User" v-model:value="task.userId" />
        </input-row>

        <input-row>
          <div>
            <label for="description">Desc</label>
            <input id="description" v-model="task.description" />
          </div>
        </input-row>
        <input-row cols="2">
          <div>
            <label for="date">Date </label>
            <input
              id="date"
              type="date"
              v-model="task.deadline"
              :min="minDate"
            />
          </div>
          <div>
            <label>Status</label>
            <select v-model="task.status">
              <option v-for="status in statuses" :key="status" :value="status">
                {{ status }}
              </option>
            </select>
          </div></input-row
        >
      </div>
      <div class="modal-actions">
        <button @click="clear">Cancel</button>
        <button class="modal-ok-btn" @click="updateTask" :disabled="!isValid">
          {{ isEdit ? "Update" : "Create" }}
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations } from "vuex";
import { initialTask, statuses } from "../utils/tasks";
import { v4 as uuid } from "uuid";
import UserSelector from "./UserSelector";
import moment from "moment";
import InputRow from "./InputRow";
import { dateFormat } from "../utils/time";

export default {
  name: "UpdateTask",
  components: { InputRow, UserSelector },
  props: { editableTask: { type: Object }, show: { type: Boolean } },
  data: () => ({ task: { ...initialTask } }),
  methods: {
    ...mapMutations(["add", "update"]),
    clear() {
      this.task = { ...initialTask };
      this.$emit("cancelEdit");
      this.$emit("update:show", false);
    },
    updateTask() {
      !this.isEdit
        ? this.add({ ...this.task, id: uuid() })
        : this.update({ task: this.task, id: this.editableTask.id });
      this.clear();
    },
  },
  computed: {
    opened() {
      return !!this.editableTask || this.show;
    },
    minDate() {
      return moment().format(dateFormat);
    },
    isEdit() {
      return !!this.editableTask;
    },
    isValid() {
      const { name, userId, deadline } = this.task;
      return !!(name && userId && deadline);
    },
    statuses() {
      return Object.values(statuses);
    },
  },
  watch: {
    editableTask(value) {
      if (value) this.task = { ...value };
    },
  },
};
</script>

<style scoped>
.modal-title {
  font-size: 24px;
  color: #585858;
  margin-bottom: 2rem;
}
.modal {
  width: 480px;
  max-width: calc(100% - 4rem);
  padding: 2rem;
  background-color: white;
  border-radius: 4px;
  margin: 5% auto;
}
.modal-wrap {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.2);
  overflow-y: auto;
}
.modal-actions {
  padding-top: 2.5rem;
  display: flex;
  justify-content: space-between;
}
.modal-content {
  display: grid;
  grid-template-rows: 1fr;
  row-gap: 1rem;
}
.modal-ok-btn {
  background-color: #4181ff;
  color: white;
  transition: background-color 0.2s, color 0.2s;
}
.modal-ok-btn:disabled {
  background-color: #a1a1a1;
}
</style>
